// Solution to Baloni problem at kattis.com

// By Giuseppe Vietri

/*
Note that that maximum number of arrows you will need is n (one for each balloon). But if an arrow can hit a 
balloon at height h then it can also hit a balloon at height h-1. Therefore, the algorithm is:

Let <ans> = n. This is going to hold the final answer. We also need a frequency array, 
F = [] to store the ballon heights. Then, we scan the ballons from left to right. For each ballon 
i, of height h we look at the array F to if there is a ballon of height h+1 came before ballon i. 
If yes, then we need one less arrow, therefore we decrease the variable <ans>.
*/

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
using namespace std;
 
int n, t;

int F[1000005];		// frequency table
 
int main() {
	
	cin >> t;           // number of test cases

	for(int tcase= 0; tcase < t; tcase++) {
		cin >> n;
		int ans = n;                 // worst case: every balloon needs an arrow
		memset(F,0,sizeof F);        // set all frequencies to zero

		for(int i = 0; i < n ; i++)
		{
			int h;
			cin >> h;                // get the balloon height
			
			if (F[h+1] > 0 ){        // is there at least 1 balloon 1 foot above?
				F[h+1] -= 1;        // if so, decrease its frequency count
				ans -= 1;           // and decrease the arrow count by 1
			}
			
			F[h] += 1;              // add 1 to the frequency count for the current height
			 
		}  // for i
		
		cout << ans << endl;
		
	}  // for tcase
 
	return 0;
}
	
	
	