/* MeanSequence.java

	Judges solution to the Mean Sequence problem.
	Modified 4/1/2018 by Irvine
 */

import java.util.Scanner;
import java.io.*;
import java.lang.reflect.Array;

public class MeanSequence
{
    public static int loadMatrix( int [] arr )
    {
        //  Variables
    	
    	// the difference between the first two mean sequence values plus 1
    	// will be the number of rows in our matrix.
        
    	int diff = arr[1]- arr[0];
    	final int size = diff + 1;
        int [][] mat = new int [ size ][ arr.length+1 ];

        //  The first column contains the first mean sequence value
        //  decreased in each row until it is less than the second
        //  mean sequence value.
        for ( int row = size-1; row > -1; row-- )  {
            mat[row][0] = arr[0] - diff;
            diff--;
        }

        // The remaining columns
        for ( int col = 1; col < arr.length+1; col++ )
        {
            for ( int row = 0; row < size; row++ )
            {
            	// let a = arr[col-1], let b = mat[row][col-1 ], let c = mat[row][col]
            	// a = (b+c)/2, or 2a = b+c, or c = 2a - b           	
            	mat[row][col] = 2 * arr[col-1] - mat[row][col-1 ];
            }
        }
        //printMatrix( mat, size, arr.length+1);      // debugging only
        return getTimes(  mat, arr[arr.length-1] );        
    }
    

    /*
     * Only sequences in which their last value is  
     * greater than or equal to the last value in the
     * mean sequence array are shown to be nondecreasing.
     */
    public static int getTimes( int[][] mat, int finalValue )
    {
        int count = 0;

        for( int[] row : mat) {
        	if( row[row.length-1] >= finalValue)
        		count++;
        }        
        return count;
    }

    public static void main( String [] args ) throws FileNotFoundException
    {

        Scanner input = new Scanner ( System.in );
        int numCases = input.nextInt();

        for ( int g = 0; g < numCases; g++ )
        {
            int numberOfValues = input.nextInt();

            int[] arr = new int[ numberOfValues ];

            //  Get input
            for ( int f = 0; f < arr.length; f++ )
                arr[f] = input.nextInt();

            System.out.println( loadMatrix( arr ) );
        }
    }

    // for debugging only
    public static void printMatrix( int[][] mat, int rows, int cols )
    {

        for ( int row = 0; row < rows; row++ )
        {
            for ( int col = 0; col < cols; col++ )
                System.out.print( mat[ row ][ col ] + " " );

            System.out.println();
        }
    }


}