import java.util.*;
import java.io.*;

//Judge Solution for Palindromes by Jesus Ramos, Division B

public class Palindromes
{
	/* A palindrome is any word that is spelled forwards the same as it is backwards
	 * in this problem you are specifically asked to ignore all characters that are not letters
     * and also to ignore the cases of the characters themselves
	 */
	public static void main(String[] args) throws Exception
	{
		Scanner in = new Scanner(System.in);
		
		//Scanner in = new Scanner(new FileReader("pal.in"));
		//PrintWriter out = new PrintWriter("pal.out");
		
		int cases = in.nextInt();
		in.nextLine(); //remember to reset the pointer in the scanner to the beginning of the next line
		//or else you will end up reading a new line character at the end of first line
		
		for (int i=0; i<cases; i++)
		{
			if (isPalindrome(strip(in.nextLine())))
				System.out.println("yes");
			else
				System.out.println("no");
		}
		//out.close();
	}
	static boolean isPalindrome(String s)
	{
		//empty strings are not palindromes
		if (s.length()==0)
			return false;
		int left = 0;
		int right = s.length()-1;
		while (left < right)
		{
			char l = s.charAt(left);
			char r = s.charAt(right);
			if (l != r)
				return false;
			left++;
			right--;
		}
		return true;
	}
	static String strip(String s) // will remove all characters that are not letters
	{
		String res = "";
		s = s.toUpperCase(); //ignore the case of the letters
		for (int i=0; i<s.length(); i++)
		{
			char c = s.charAt(i);
			if (Character.isLetter(c))
				res+=""+c;
		}
		return res;
	}
}
