// Playing with Wheels (uva 10067)

/*
	A 4-digit integer has at most 10,000 possible states.
	From any single state, you can produce 8 possible states by rotating a single
	wheel up or down by 1 position. For example, from 8056,
	the following states can be reached: 
		8057, 8066, 8156, 9056
		8055, 8046, 8956, 7056

	Use a BFS to visit each state as if it were a vertex in a connected graph.
	Each state, when visited, should be marked. The forbidden states can be marked
	even before starting the BFS.
*/

// Source code from  tausiq.wordpress.com
 
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <string>
#include <cctype>
#include <stack>
#include <queue>
#include <list>
#include <vector>
#include <map>
#include <sstream>
#include <cmath>
#include <bitset>
#include <utility>
#include <set>
#define INT_MAX 2147483647
#define INT_MIN -2147483648
#define pi acos(-1.0)
#define N 1000000
#define LL long long
using namespace std;
 
int power (int b, int p)
{
    if ( p == 4 ) return 10000;
    if ( p == 3 ) return 1000;
    if ( p == 2 ) return 100;
    if ( p == 1 ) return 10;
    return 1;
}
 
int make_number (int c [])
{
    int ret = 0;
 
    ret += c [0] * 1000;
    ret += c [1] * 100;
    ret += c [2] * 10;
    ret += c [3];
 
    return ret;
}
 
int main ()
{
    int testCase;
    scanf ("%d", &testCase);
 
    while ( testCase-- ) {
        int input;
        int pressCnt [10000 + 10];
        bool visited [10000 + 10];
        queue <int> q;
 
        memset (pressCnt, 0, sizeof (pressCnt));
        memset (visited, 0, sizeof (visited));
 
        int number = 0;
        for ( int i = 0; i < 4; i++ ) {
            scanf ("%d", &input);
            number += (input * power (10, 3 - i));
        }
 
        pressCnt [number] = 0;
        q.push (number);
 
        int destination = 0;
 
        for ( int i = 0; i < 4; i++ ) {
            scanf ("%d", &input);
            destination += (input * power (10, 3 - i));
        }
 
        int n;
        scanf ("%d", &n);
 
        for ( int i = 0; i < n; i++ ) {
            number = 0;
            for ( int j = 0; j < 4; j++ ) {
                scanf ("%d", &input);
                number += (input * power (10, 3 - j));
            }
            visited [number] = true;
        }
 
        bool resultFound = false;
 
        while ( !q.empty () ) {
            number = q.front ();
            q.pop ();
 
            if ( visited [number] == true ) continue;
 
            visited [number] = true;
 
            if ( number == destination ) {
                resultFound = true;
                break;
            }
 
            int child [4];
            child [3] = number % 10;
            child [2] = (number % 100) / 10;
            child [1] = (number % 1000) / 100;
            child [0] = number / 1000;
 
            for ( int i = 0; i < 4; i++ ) {
                child [i] += 1;
                child [i] %= 10;
                int num = make_number (child);
                if ( visited [num] == false )
                    q.push (num);
                pressCnt [num] = pressCnt [number] + 1;
 
                child [3] = number % 10;
                child [2] = (number % 100) / 10;
                child [1] = (number % 1000) / 100;
                child [0] = number / 1000;
            }
 
            for ( int i = 0; i < 4; i++ ) {
                child [i] -= 1;
                if ( child [i] == -1 ) child [i] = 9;
                int num = make_number (child);
                if ( visited [num] == false )
                    q.push (num);
                pressCnt [num] = pressCnt [number] + 1;
 
                child [3] = number % 10;
                child [2] = (number % 100) / 10;
                child [1] = (number % 1000) / 100;
                child [0] = number / 1000;
            }
        }
 
        if ( resultFound ) printf ("%d\n", pressCnt [destination]);
        else printf ("-1\n");
    }
 
    return 0;
}
 
