// TODO: Modify to handle multiple test cases.
// The original solution is by David van Brackle.
// It was modified by Kip Irvine to handle multiple test cases.

import java.io.*;
import java.util.*;
import java.awt.geom.*;

public class blur
{
    public Scanner sc;
    public PrintStream ps;
        

    void oneTestCase() {
    	
        int w = sc.nextInt();
        int h = sc.nextInt();
        int b = sc.nextInt();
        
        // We're going to store b+1 images, one for each blurring actions.
        // It's more memory efficient to just keep 2 and swap them, but 
        // that requires more programming, and the numbers are small enough
        // that it should not be a problem.
        int image[][][] = new int[h][w][b+1];
		
        for( int i=0; i<h; i++ ) 
			for( int j=0; j<w; j++ )
			{
				// We'll put the starting image at image[*][*][b].
				// The final image will end up at image[*][*][0].
				image[i][j][b] = sc.nextInt();
			}
        
        // Blur b times. We'll keep the sum of the 9 cells around a pixel, rather than the average.
        // The average is a bit of a red herring. The integer sum will be all we need 
        // to check uniqueness. The average will be a real number, and comparing reals for equality
        // is problematic.
        for( int k=b; k>0; k-- ) 
			for( int i=0; i<h; i++ ) 
				for( int j=0; j<w; j++ )
				{
					int sum = 0;
					for( int di=-1; di<=1; di++ ) 
						for( int dj=-1; dj<=1; dj++)
						{
							sum += image[(i+di+h)%h][(j+dj+w)%w][k];
						}
					image[i][j][k-1] = sum;
				}
        
        // We're really lazy, so we'll use a HashSet to count unique colors.
        HashSet<Integer> colors = new HashSet<Integer>();
        for( int i=0; i<h; i++ ) for( int j=0; j<w; j++ )
        {
            colors.add( image[i][j][0] );
        }
        
        ps.println( colors.size() );
    }
        
    public void doit() throws Exception
    {
        sc = new Scanner( System.in );
        ps = System.out;
        int numTestCases = sc.nextInt();
        for(int i=0; i < numTestCases; i++)
        	oneTestCase();
    }
    
    public static void main( String[] args ) throws Exception
    {
        new blur().doit();        
    }   
}
